C Sp0.f
C
C VIS-5D function to calculate PERTURBATION first-guess of streamfunction (Sp0)

C ==============================================================================

      INTEGER FUNCTION USERFUNC( OUTGRID, OUTNL, OUTLOWLEV,
     *                           INGRID, NR, NC, NL, LOWLEV, MAXNL,
     *                           NVARS, NAMES,
     *                           DATE, TIME,
     *                           PROJECTION, PROJ_ARGS,
     *                           VERTICAL, VERT_ARGS )
C ARGUMENTS:
      implicit none
      INTEGER NVARS
      INTEGER NR, NC, NL(NVARS), LOWLEV(NVARS), MAXNL
      REAL OUTGRID(NR,NC,MAXNL)
      INTEGER OUTNL, OUTLOWLEV
      REAL INGRID(NR,NC,MAXNL,NVARS)
      CHARACTER*8 NAMES(NVARS)
      INTEGER DATE, TIME
      INTEGER PROJECTION
      REAL PROJ_ARGS(*)
      INTEGER VERTICAL
      REAL VERT_ARGS(*)

C LOCAL VARS:
      integer var, ir, ic, il
      integer is0, ism0  

C ==============================================================================
      
C Specify number of levels in OUTGRID
      OUTNL = MAXNL
      OUTLOWLEV = 0
      
C Find the S0 and Sm0 variables (TOTAL and MEAN fields)
      is0 = -1
      ism0 = -1
      do var=1,nvars
        if (names(var) .eq. 'S0') is0 = var
        if (names(var) .eq. 'Sm0') ism0 = var        
      end do

C If S0 or Sm0 not found, return error 1
      if ( is0.eq.-1 .or. ism0.eq.-1 ) then
        print *, 
     $  "Couldn't find S0 or Sm0 vars!"
        userfunc = 1
        return
      endif

C ==============================================================================

C OUTPUT OF PERTURBATION FIRST-GUESS OF STREAMFUNCTION Sp0 (=S0-Sm0) 

      print*,
     $'Output of PERTURBATION first guess of streamfunction ',
     $'Sp0 ([grav/Fndim] m2 s-1)'
      DO 9999 ir=1,nr
      DO 9999 ic=1,nc
      DO 9999 il=1,maxnl
        outgrid(ir,ic,il)=ingrid(ir,ic,il,is0)-
     $                    ingrid(ir,ic,il,ism0)
9999  CONTINUE     

C ==============================================================================
               
      USERFUNC = 0
      RETURN
      END

C ==============================================================================
